struct CActionCode
{
	char* Name;
	DWORD Code;
};

extern CActionCode ActionCodes[];


// 11------ -------- -------- --------
#define ACTF_ALTCODE 				0x80000000		// ignored; used to generate a different code# for the same code

// -111---- -------- -------- --------
#define ACTF_NO_DOWN  				0x40000000
#define ACTF_ON_UP  				0x20000000		
#define ACTF_ON_REPEAT				0x10000000

// -----111 -------- -------- --------
#define ACTF_F_MASK					0x0F000000
#define ACTF_F_SPECIAL				0x00000000
#define ACTF_F_KEYDOWN				0x01000000		//
//#define ACTF_F_WMCOMMAND   			0x02000000		// postmesssage(wm_command)
//#define ACTF_F_WMCOMMAND_S 		0x03000000		// sendmessage(wm_command)

// -------- -------- ---11111 --------
#define ACTF_KEY_CTRL				0x00000100
//#define ACTF_KEY_ALT				0x00000200
//#define ACTF_KEY_SHIFT			0x00000400
//#define ACTF_KEY_POST				0x00000800

//
#define ACTF_KEY_VALUE_MASK			0x000000FF
#define ACTF_WMCOMMAND_VALUE_MASK	0x0000FFFF
#define ACTF_SPECIAL_VALUE_MASK		0x0000FFFF


//
// PowerDVD XP 4.0 Notes
//
// - There's not much WM_COMMAND activity in PowerDVD, so use keyboard.
// - 
//

//
#define ACT_NONE			0	// don't claim the code
#define ACT_IGNORE			1	// eat the code

#define ACT_PLUGINSETUP		(0x11|ACTF_NO_DOWN|ACTF_ON_UP)

// --begin-- must be grouped together
#define ACT_MENUTITLE		0x100
#define ACT_MENUROOT		0x101
#define ACT_MENUSUBTITLES	0x102
#define ACT_MENUAUDIO		0x103
#define ACT_MENUANGLE		0x104
#define ACT_MENUCHAPTER		0x105
#define ACT_RESUME			0x106
// --end--

#define ACT_MIXVOLMUTE		(0x200|ACTF_ON_UP|ACTF_ON_REPEAT)
#define ACT_MIXVOLUP		(0x201|ACTF_ON_UP|ACTF_ON_REPEAT)
#define ACT_MIXVOLDN		(0x202|ACTF_ON_UP|ACTF_ON_REPEAT)


#define ACT_VOLUMEUP		(ACTF_F_KEYDOWN|VK_ADD|ACTF_ON_REPEAT)
#define ACT_VOLUMEDOWN		(ACTF_F_KEYDOWN|VK_SUBTRACT|ACTF_ON_REPEAT)
#define ACT_VOLUMEMUTE		(ACTF_F_KEYDOWN|'Q')
#define ACT_FULLSCREEN		(ACTF_F_KEYDOWN|'Z')
#define ACT_MINIMIZE		(ACTF_F_KEYDOWN|ACTF_KEY_CTRL|'N')
#define ACT_EXIT			(ACTF_F_KEYDOWN|ACTF_KEY_CTRL|'X')
#define ACT_CAPTURE			(ACTF_F_KEYDOWN|'C')
#define ACT_RETURN			(ACTF_F_KEYDOWN|'R')
#define ACT_AUDIO			(ACTF_F_KEYDOWN|'H')
#define ACT_SUBTITLE		(ACTF_F_KEYDOWN|'U')
#define ACT_CONFIG			(ACTF_F_KEYDOWN|ACTF_KEY_CTRL|'C')
#define ACT_EJECT			(ACTF_F_KEYDOWN|ACTF_KEY_CTRL|'E'|ACTF_NO_DOWN|ACTF_ON_UP)
#define ACT_OPEN			(ACTF_F_KEYDOWN|'O')	// also CTRL+O
#define ACT_SKINMODE		(ACTF_F_KEYDOWN|ACTF_KEY_CTRL|'T')
#define ACT_KEYPAD			(ACTF_F_KEYDOWN|VK_DIVIDE)
#define ACT_KARAOKE			(ACTF_F_KEYDOWN|'K')
#define ACT_ANGLE			(ACTF_F_KEYDOWN|'A')
#define ACT_REPEATMODE		(ACTF_F_KEYDOWN|ACTF_KEY_CTRL|'R')
#define ACT_ADDBOOKMARK		(ACTF_F_KEYDOWN|'M')
#define ACT_SHOWBOOKMARK	(ACTF_F_KEYDOWN|VK_F2)
#define ACT_PLAY			(ACTF_F_KEYDOWN|VK_RETURN|ACTF_NO_DOWN|ACTF_ON_UP)
#define ACT_STOP			(ACTF_F_KEYDOWN|'S')
#define ACT_PAUSE			(ACTF_F_KEYDOWN|VK_SPACE)
#define ACT_STEPFORWARD		(ACTF_F_KEYDOWN|'T'|ACTF_ON_REPEAT)
#define ACT_STEPBACK		(ACTF_F_KEYDOWN|ACTF_KEY_CTRL|'B'|ACTF_ON_REPEAT)
#define ACT_CHAPTERPREV		(ACTF_F_KEYDOWN|'P')
#define ACT_CHAPTERNEXT		(ACTF_F_KEYDOWN|'N')
#define ACT_FASTFORWARD		(ACTF_F_KEYDOWN|'F')
#define ACT_REWIND			(ACTF_F_KEYDOWN|'B')
#define ACT_FORWARD5    	(ACTF_F_KEYDOWN|VK_NEXT|ACTF_ON_REPEAT)
#define ACT_BACKWARD5    	(ACTF_F_KEYDOWN|VK_PRIOR|ACTF_ON_REPEAT)
#define ACT_REPEATAB    	(ACTF_F_KEYDOWN|'X')
/* 
Doesn't work on all languages?
#define ACT_0				(ACTF_F_KEYDOWN|'0')
#define ACT_1				(ACTF_F_KEYDOWN|'1')
#define ACT_2				(ACTF_F_KEYDOWN|'2')
#define ACT_3				(ACTF_F_KEYDOWN|'3')
#define ACT_4				(ACTF_F_KEYDOWN|'4')
#define ACT_5				(ACTF_F_KEYDOWN|'5')
#define ACT_6				(ACTF_F_KEYDOWN|'6')
#define ACT_7				(ACTF_F_KEYDOWN|'7')
#define ACT_8				(ACTF_F_KEYDOWN|'8')
#define ACT_9				(ACTF_F_KEYDOWN|'9')
*/
#define ACT_0				(ACTF_F_KEYDOWN|VK_NUMPAD0)
#define ACT_1				(ACTF_F_KEYDOWN|VK_NUMPAD1)
#define ACT_2				(ACTF_F_KEYDOWN|VK_NUMPAD2)
#define ACT_3				(ACTF_F_KEYDOWN|VK_NUMPAD3)
#define ACT_4				(ACTF_F_KEYDOWN|VK_NUMPAD4)
#define ACT_5				(ACTF_F_KEYDOWN|VK_NUMPAD5)
#define ACT_6				(ACTF_F_KEYDOWN|VK_NUMPAD6)
#define ACT_7				(ACTF_F_KEYDOWN|VK_NUMPAD7)
#define ACT_8				(ACTF_F_KEYDOWN|VK_NUMPAD8)
#define ACT_9				(ACTF_F_KEYDOWN|VK_NUMPAD9)

#define ACT_UP				(ACTF_F_KEYDOWN|VK_UP)
#define ACT_DOWN			(ACTF_F_KEYDOWN|VK_DOWN)
#define ACT_LEFT			(ACTF_F_KEYDOWN|VK_LEFT)
#define ACT_RIGHT			(ACTF_F_KEYDOWN|VK_RIGHT)
